//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//@ft[WGtFNg v0.3
//@@@by iuser/5145841j
//
//@@@̃tB^͂ڂl̃fBt[WtB^
//@@@@邢{J{̌ʂ̂ݓ悤ɂ̂łB
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//@[U[p[^

//@ڂ͈(TvO͌Œ̂߁A傫ƎȂo܂)
//@@ݒ 0.001953125i=2^-9j
float Extent
<
   string UIName = "Extent";
   string UIWidget = "Slider";
   bool UIVisible =  true;
   float UIMin = 0.00;
   float UIMax = 0.01;
> = float( 0.001953125 );

//@MMDo͂ƍ䗦i0ŕωȂA1ɋ߂ÂقǃGtFNgj
//@@ݒ 0.6666667i= 2/3j
float Strength
<
   string UIName = "Strength";
   string UIWidget = "Slider";
   bool UIVisible =  true;
   float UIMin = 0.0;
   float UIMax = 1.0;
> = float( 0.6666667 );

//@ȈՐF␳i , , i,j̏ɎwA1ŕωȂj
//@@ݒ 1.0, 1.0, 1.0, 1.0
float4 ColorFilter
<
   string UIName = "ColorFilter";
   string UIWidget = "Color";
   bool UIVisible =  true;
   float UIMin = float4( 0, 0, 0, 1);
   float UIMax = float4( 2, 2, 2, 1);
> = float4( 1.0, 1.0, 1.0, 1.0 );

float Script : STANDARDSGLOBAL <
    string ScriptOutput = "color";
    string ScriptClass = "scene";
    string ScriptOrder = "postprocess";
> = 0.8;

//@}eAF
float4 MaterialDiffuse : DIFFUSE  < string Object = "Geometry"; >;
static float alpha1 = MaterialDiffuse.a;

float scaling0 : CONTROLOBJECT < string name = "(self)"; >;
static float scaling = scaling0 * 0.1;

//@XN[TCY
float2 ViewportSize : VIEWPORTPIXELSIZE;

static float2 ViewportOffset = (float2(0.5,0.5)/ViewportSize);

static float2 SampStep = (float2(Extent,Extent)/ViewportSize*ViewportSize.y) * scaling;

//@_O^[Qbg̃NAl
float4 ClearColor = {1,1,1,1};
float ClearDepth  = 1.0;

//ڂ̃TvO
#define SAMP_NUM  7

//@[xobt@
texture2D DepthBuffer : RENDERDEPTHSTENCILTARGET <
    float2 ViewPortRatio = {1.0,1.0};
    string Format = "D24S8";
>;

//@IWi̕`挋ʂL^邽߂̃_[^[Qbg
texture2D ScnMap : RENDERCOLORTARGET <
    float2 ViewPortRatio = {1.0,1.0};
    int MipLevels = 1;
    string Format = "A8R8G8B8" ;
>;
sampler2D ScnSamp = sampler_state {
    texture = <ScnMap>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;
    AddressU  = CLAMP;
    AddressV = CLAMP;
};

//@ȏZX̂ڂʂL^邽߂̃_[^[Qbg
texture2D ScnMap2 : RENDERCOLORTARGET <
    float2 ViewPortRatio = {1.0,1.0};
    int MipLevels = 1;
    string Format = "A8R8G8B8" ;
>;
sampler2D ScnSamp2 = sampler_state {
    texture = <ScnMap2>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;
    AddressU  = CLAMP;
    AddressV = CLAMP;
};

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
// ʒ_VF[_
struct VS_OUTPUT {
    float4 Pos            : POSITION;
    float2 Tex            : TEXCOORD0;
};

VS_OUTPUT VS_passDraw( float4 Pos : POSITION, float4 Tex : TEXCOORD0 ) {
    VS_OUTPUT Out = (VS_OUTPUT)0; 
    
    Out.Pos = Pos;
    Out.Tex = Tex + ViewportOffset;
    
    return Out;
}


//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
// Xڂ

float4 PS_passX( float2 Tex: TEXCOORD0 ) : COLOR {   
    float4 Color, sum = 0;
    float e, n = 0;
    
    [unroll] //[vWJ
    for(int i = -SAMP_NUM; i <= SAMP_NUM; i++){
        e = exp(-pow(i / (SAMP_NUM / 2.0), 2) / 2); //Kz
        
        Color = tex2D( ScnSamp, Tex + float2(SampStep.x * i, 0) );
        Color.rgb = pow(Color.rgb, 2); //RGB2
        sum += Color * e;
        n += e;
    }
    
    return sum / n;
}

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
// Yڂ + 

float4 PS_passY(float2 Tex: TEXCOORD0) : COLOR
{   
    const float4 ColorOrg = tex2D(ScnSamp, Tex);
    const float4 ColorSrc = pow(ColorOrg, 2);
    float4 Color, sum = 0;
    
    float e, n = 0;
    
    [unroll] //[vWJ
    for(int i = -SAMP_NUM; i <= SAMP_NUM; i++){
        e = exp(-pow(i / (SAMP_NUM / 2.0), 2) / 2); //Kz
        sum += tex2D( ScnSamp2, Tex + float2(0, SampStep.y * i) ) * e;
        n += e;
    }
    
    Color = sum / n;
    
    // Color = Z + {JiPbj@ColorW = ʁ@ColorSrc = ZiPaj@ColorOrg = MMD

    //@XN[
    Color = ColorSrc + Color - ColorSrc * Color;

	//@F␳ʂÂɔႳč
	ColorFilter.a = 1.0;
    Color = lerp(Color, Color * ColorFilter, 1 - Color);

	//@MMD o͂ƍʂrijŃuh
    Color.r = ColorOrg.r > Color.r ? ColorOrg.r : Color.r;
    Color.g = ColorOrg.g > Color.g ? ColorOrg.g : Color.g;
    Color.b = ColorOrg.b > Color.b ? ColorOrg.b : Color.b;

	//@䗦ƃANZT̕sxɃIWiƍ
    return lerp(ColorOrg, Color ,Strength * alpha1);
}

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

technique Diffusion <
    string Script = 
        
        "RenderColorTarget0=ScnMap;"
        "RenderDepthStencilTarget=DepthBuffer;"
        "ClearSetColor=ClearColor;"
        "ClearSetDepth=ClearDepth;"
        "Clear=Color;"
        "Clear=Depth;"
        "ScriptExternal=Color;"
        
        "RenderColorTarget0=ScnMap2;"
        "RenderDepthStencilTarget=DepthBuffer;"
        "ClearSetColor=ClearColor;"
        "ClearSetDepth=ClearDepth;"
        "Clear=Color;"
        "Clear=Depth;"
        "Pass=Gaussian_X;"
        
        "RenderColorTarget0=;"
        "RenderDepthStencilTarget=;"
        "ClearSetColor=ClearColor;"
        "ClearSetDepth=ClearDepth;"
        "Clear=Color;"
        "Clear=Depth;"
        "Pass=Gaussian_Y;"
    ;
    
> {
    pass Gaussian_X < string Script= "Draw=Buffer;"; > {
        AlphaBlendEnable = FALSE;
        VertexShader = compile vs_3_0 VS_passDraw();
        PixelShader  = compile ps_3_0 PS_passX();
    }
    pass Gaussian_Y < string Script= "Draw=Buffer;"; > {
        AlphaBlendEnable = FALSE;
        VertexShader = compile vs_3_0 VS_passDraw();
        PixelShader  = compile ps_3_0 PS_passY();
    }
}
////////////////////////////////////////////////////////////////////////////////////////////////
